﻿using System.Drawing;
using System.Windows.Forms;

using Steema.TeeChart;
using Steema.TeeChart.Drawing;
using Steema.TeeChart.Styles;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 이미지 리스트
        /// </summary>
        private ImageList imageList;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Text = "TChart 클래스 : Legend 속성을 사용해 레전드 기호 대신 이미지 그리기";

            this.tChart.Panel.Pen = new ChartPen(Color.Black);

            this.tChart.Legend.VertSpacing       = 8;
            this.tChart.Legend.Symbol.WidthUnits = LegendSymbolSize.Pixels;
            this.tChart.Legend.Symbol.DefaultPen = false;
            this.tChart.Legend.Font.Size         = 12;

            Pie pie = new Pie(this.tChart.Chart);

            pie.FillSampleValues(8);

            this.imageList = new ImageList();

            this.imageList.Images.Add(Properties.Resources.image1);
            this.imageList.Images.Add(Properties.Resources.image2);
            this.imageList.Images.Add(Properties.Resources.image3);
            this.imageList.Images.Add(Properties.Resources.image4);
            this.imageList.Images.Add(Properties.Resources.image5);
            this.imageList.Images.Add(Properties.Resources.image6);
            this.imageList.Images.Add(Properties.Resources.image7);
            this.imageList.Images.Add(Properties.Resources.image8);

            this.tChart.Legend.Symbol.OnSymbolDraw += tChartLegendSymbol_OnSymbolDraw;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region TChart 레전드 기호 기호 그리기시 처리하기 - tChartLegendSymbol_OnSymbolDraw(sender, e)

        /// <summary>
        /// TChart 레전드 기호 기호 그리기시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void tChartLegendSymbol_OnSymbolDraw(object sender, SymbolDrawEventArgs e)
        {
            Bitmap bitmap = new Bitmap(this.imageList.Images[e.ValueIndex]);

            this.tChart.Chart.Graphics3D.FillRectangle
            (
                Brushes.White,
                e.Rect.Left - 1,
                e.Rect.Top - 1,
                e.Rect.Width + 2,
                e.Rect.Height + 2
            );

            this.tChart.Chart.Graphics3D.Draw(e.Rect, bitmap, ImageMode.Normal, true);
        }

        #endregion
    }
}